Index: uspace/srv/ns/ns.c
===================================================================
--- uspace/srv/ns/ns.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/ns/ns.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,5 +36,6 @@
  */
 
-#include <ipc/ipc.h>
+#include <abi/ipc/methods.h>
+#include <async.h>
 #include <ipc/ns.h>
 #include <ipc/services.h>
@@ -47,4 +48,82 @@
 #include "clonable.h"
 #include "task.h"
+
+static void ns_connection(ipc_callid_t iid, ipc_call_t *icall, void *arg)
+{
+	ipc_call_t call;
+	ipc_callid_t callid;
+	iface_t iface;
+	service_t service;
+
+	iface = IPC_GET_ARG1(*icall);
+	service = IPC_GET_ARG2(*icall);
+	if (service != 0) {
+		/*
+		 * Client requests to be connected to a service.
+		 */
+		if (service_clonable(service)) {
+			connect_to_clonable(service, iface, icall, iid);
+		} else {
+			connect_to_service(service, iface, icall, iid);
+		}
+		return;
+	}
+	
+	async_answer_0(iid, EOK);
+
+	while (true) {
+		process_pending_conn();
+		
+		callid = async_get_call(&call);
+		if (!IPC_GET_IMETHOD(call))
+			break;
+		
+		task_id_t id;
+		sysarg_t retval;
+		
+		service_t service;
+		sysarg_t phone;
+		
+		switch (IPC_GET_IMETHOD(call)) {
+		case NS_REGISTER:
+			service = IPC_GET_ARG1(call);
+			phone = IPC_GET_ARG5(call);
+			
+			/*
+			 * Server requests service registration.
+			 */
+			if (service_clonable(service)) {
+				register_clonable(service, phone, &call, callid);
+				continue;
+			} else {
+				retval = register_service(service, phone, &call);
+			}
+			
+			break;
+		case NS_PING:
+			retval = EOK;
+			break;
+		case NS_TASK_WAIT:
+			id = (task_id_t)
+			    MERGE_LOUP32(IPC_GET_ARG1(call), IPC_GET_ARG2(call));
+			wait_for_task(id, &call, callid);
+			continue;
+		case NS_ID_INTRO:
+			retval = ns_task_id_intro(&call);
+			break;
+		case NS_RETVAL:
+			retval = ns_task_retval(&call);
+			break;
+		default:
+			printf("ns: method not supported\n");
+			retval = ENOTSUP;
+			break;
+		}
+		
+		async_answer_0(callid, retval);
+	}
+
+	(void) ns_task_disconnect(&call);
+}
 
 int main(int argc, char **argv)
@@ -64,74 +143,8 @@
 		return rc;
 	
+	async_set_fallback_port_handler(ns_connection, NULL);
+	
 	printf("%s: Accepting connections\n", NAME);
-	
-	while (true) {
-		process_pending_conn();
-		
-		ipc_call_t call;
-		ipc_callid_t callid = ipc_wait_for_call(&call);
-		
-		task_id_t id;
-		sysarg_t retval;
-		
-		iface_t iface;
-		service_t service;
-		sysarg_t phone;
-		
-		switch (IPC_GET_IMETHOD(call)) {
-		case IPC_M_PHONE_HUNGUP:
-			retval = ns_task_disconnect(&call);
-			break;
-		case IPC_M_CONNECT_TO_ME:
-			service = IPC_GET_ARG2(call);
-			phone = IPC_GET_ARG5(call);
-			
-			/*
-			 * Server requests service registration.
-			 */
-			if (service_clonable(service)) {
-				register_clonable(service, phone, &call, callid);
-				continue;
-			} else
-				retval = register_service(service, phone, &call);
-			
-			break;
-		case IPC_M_CONNECT_ME_TO:
-			iface = IPC_GET_ARG1(call);
-			service = IPC_GET_ARG2(call);
-			
-			/*
-			 * Client requests to be connected to a service.
-			 */
-			if (service_clonable(service)) {
-				connect_to_clonable(service, iface, &call, callid);
-				continue;
-			} else {
-				connect_to_service(service, iface, &call, callid);
-				continue;
-			}
-			break;
-		case NS_PING:
-			retval = EOK;
-			break;
-		case NS_TASK_WAIT:
-			id = (task_id_t)
-			    MERGE_LOUP32(IPC_GET_ARG1(call), IPC_GET_ARG2(call));
-			wait_for_task(id, &call, callid);
-			continue;
-		case NS_ID_INTRO:
-			retval = ns_task_id_intro(&call);
-			break;
-		case NS_RETVAL:
-			retval = ns_task_retval(&call);
-			break;
-		default:
-			retval = ENOENT;
-			break;
-		}
-		
-		if (!(callid & IPC_CALLID_NOTIFICATION))
-			ipc_answer_0(callid, retval);
-	}
+	async_manager();
 	
 	/* Not reached */
Index: uspace/srv/ns/service.c
===================================================================
--- uspace/srv/ns/service.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/ns/service.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -31,7 +31,7 @@
  */
 
-#include <ipc/ipc.h>
 #include <adt/hash_table.h>
 #include <assert.h>
+#include <async.h>
 #include <errno.h>
 #include <stdio.h>
@@ -47,9 +47,6 @@
 	service_t service;
 	
-	/** Phone registered with the interface */
-	sysarg_t phone;
-	
-	/** Incoming phone hash */
-	sysarg_t in_phone_hash;
+	/** Session to the service */
+	async_sess_t *sess;
 } hashed_service_t;
 
@@ -121,6 +118,8 @@
 		
 		hashed_service_t *hashed_service = hash_table_get_inst(link, hashed_service_t, link);
-		(void) ipc_forward_fast(pending->callid, hashed_service->phone,
-		    pending->iface, pending->arg3, 0, IPC_FF_NONE);
+		async_exch_t *exch = async_exchange_begin(hashed_service->sess);
+		async_forward_fast(pending->callid, exch, pending->iface,
+		    pending->arg3, 0, IPC_FF_NONE);
+		async_exchange_end(exch);
 		
 		list_remove(&pending->link);
@@ -151,9 +150,9 @@
 	
 	hashed_service->service = service;
-	hashed_service->phone = phone;
-	hashed_service->in_phone_hash = call->in_phone_hash;
+	hashed_service->sess = async_callback_receive(EXCHANGE_SERIALIZE);
+	if (hashed_service->sess == NULL)
+		return EIO;
 	
 	hash_table_insert(&service_hash_table, &hashed_service->link);
-	
 	return EOK;
 }
@@ -202,11 +201,11 @@
 	
 	hashed_service_t *hashed_service = hash_table_get_inst(link, hashed_service_t, link);
-	(void) ipc_forward_fast(callid, hashed_service->phone, iface, arg3,
-	    0, IPC_FF_NONE);
+	async_exch_t *exch = async_exchange_begin(hashed_service->sess);
+	async_forward_fast(callid, exch, iface, arg3, 0, IPC_FF_NONE);
+	async_exchange_end(exch);
 	return;
 	
 out:
-	if (!(callid & IPC_CALLID_NOTIFICATION))
-		ipc_answer_0(callid, retval);
+	async_answer_0(callid, retval);
 }
 
Index: uspace/srv/ns/task.c
===================================================================
--- uspace/srv/ns/task.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/ns/task.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -32,6 +32,6 @@
  */
 
-#include <ipc/ipc.h>
 #include <adt/hash_table.h>
+#include <async.h>
 #include <stdbool.h>
 #include <errno.h>
@@ -182,10 +182,7 @@
 			continue;
 		
-		if (!(pr->callid & IPC_CALLID_NOTIFICATION)) {
-			texit = ht->have_rval ? TASK_EXIT_NORMAL :
-			    TASK_EXIT_UNEXPECTED;
-			ipc_answer_2(pr->callid, EOK, texit,
-			    ht->retval);
-		}
+		texit = ht->have_rval ? TASK_EXIT_NORMAL :
+		    TASK_EXIT_UNEXPECTED;
+		async_answer_2(pr->callid, EOK, texit, ht->retval);
 		
 		list_remove(&pr->link);
@@ -203,5 +200,5 @@
 	if (ht == NULL) {
 		/* No such task exists. */
-		ipc_answer_0(callid, ENOENT);
+		async_answer_0(callid, ENOENT);
 		return;
 	}
@@ -210,5 +207,5 @@
 		task_exit_t texit = ht->have_rval ? TASK_EXIT_NORMAL :
 		    TASK_EXIT_UNEXPECTED;
-		ipc_answer_2(callid, EOK, texit, ht->retval);
+		async_answer_2(callid, EOK, texit, ht->retval);
 		return;
 	}
@@ -218,6 +215,5 @@
 	    (pending_wait_t *) malloc(sizeof(pending_wait_t));
 	if (!pr) {
-		if (!(callid & IPC_CALLID_NOTIFICATION))
-			ipc_answer_0(callid, ENOMEM);
+		async_answer_0(callid, ENOMEM);
 		return;
 	}
@@ -282,4 +278,24 @@
 int ns_task_retval(ipc_call_t *call)
 {
+	task_id_t id = call->in_task_id;
+	
+	ht_link_t *link = hash_table_find(&task_hash_table, &id);
+	hashed_task_t *ht = (link != NULL) ?
+	    hash_table_get_inst(link, hashed_task_t, link) : NULL;
+	
+	if ((ht == NULL) || (ht->finished))
+		return EINVAL;
+	
+	ht->finished = true;
+	ht->have_rval = true;
+	ht->retval = IPC_GET_ARG1(*call);
+	
+	process_pending_wait();
+	
+	return EOK;
+}
+
+int ns_task_disconnect(ipc_call_t *call)
+{
 	task_id_t id;
 	int rc = get_id_by_phone(call->in_phone_hash, &id);
@@ -287,27 +303,4 @@
 		return rc;
 	
-	ht_link_t *link = hash_table_find(&task_hash_table, &id);
-	hashed_task_t *ht = (link != NULL) ?
-	    hash_table_get_inst(link, hashed_task_t, link) : NULL;
-	
-	if ((ht == NULL) || (ht->finished))
-		return EINVAL;
-	
-	ht->finished = true;
-	ht->have_rval = true;
-	ht->retval = IPC_GET_ARG1(*call);
-	
-	process_pending_wait();
-	
-	return EOK;
-}
-
-int ns_task_disconnect(ipc_call_t *call)
-{
-	task_id_t id;
-	int rc = get_id_by_phone(call->in_phone_hash, &id);
-	if (rc != EOK)
-		return rc;
-	
 	/* Delete from phone-to-id map. */
 	hash_table_remove(&phone_to_id, &call->in_phone_hash);
Index: uspace/srv/taskmon/taskmon.c
===================================================================
--- uspace/srv/taskmon/taskmon.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/taskmon/taskmon.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -38,5 +38,4 @@
 #include <async.h>
 #include <ipc/services.h>
-#include <sys/typefmt.h>
 #include <task.h>
 #include <ipc/corecfg.h>
Index: uspace/srv/volsrv/Makefile
===================================================================
--- uspace/srv/volsrv/Makefile	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/volsrv/Makefile	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -29,6 +29,11 @@
 USPACE_PREFIX = ../..
 
-LIBS = $(LIBBLOCK_PREFIX)/libblock.a
-EXTRA_CFLAGS = -I $(LIBBLOCK_PREFIX)
+LIBS = \
+	$(LIBLABEL_PREFIX)/liblabel.a \
+	$(LIBBLOCK_PREFIX)/libblock.a
+
+EXTRA_CFLAGS = \
+	-I$(LIBLABEL_PREFIX)/include \
+	-I$(LIBBLOCK_PREFIX)
 
 BINARY = volsrv
Index: uspace/srv/volsrv/empty.c
===================================================================
--- uspace/srv/volsrv/empty.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/volsrv/empty.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -38,4 +38,5 @@
 #include <errno.h>
 #include <io/log.h>
+#include <label/empty.h>
 #include <loc.h>
 #include <stdlib.h>
@@ -43,70 +44,21 @@
 #include "empty.h"
 
-/*
- * The partition will be considered empty if at least a minimum number of
- * bytes *and* blocks (whichever is larger) at the beginning and end of
- * the partition is zero.
- */
-enum {
-	min_empty_bytes = 16384,
-	/*
-	 * First block in ISO 9660 that cannot be empty is the first
-	 * volume descriptor at LBA 16
-	 */
-	min_empty_blocks = 17
+static int empty_get_bsize(void *, size_t *);
+static int empty_get_nblocks(void *, aoff64_t *);
+static int empty_read(void *, aoff64_t, size_t, void *);
+static int empty_write(void *, aoff64_t, size_t, const void *);
+
+/** Provide disk access to liblabel */
+static label_bd_ops_t empty_bd_ops = {
+	.get_bsize = empty_get_bsize,
+	.get_nblocks = empty_get_nblocks,
+	.read = empty_read,
+	.write = empty_write
 };
-
-static bool mem_is_zero(void *buf, size_t size)
-{
-	uint8_t *bp;
-	size_t i;
-
-	bp = (uint8_t *)buf;
-	for (i = 0; i < size; i++) {
-		if (bp[i] != 0)
-			return false;
-	}
-
-	return true;
-}
-
-/** Calculate number of blocks to check.
- *
- * Will store to @a *ncb the number of blocks that should be checked
- * at the beginning and end of device each.
- *
- * @param nblocks Total number of blocks on block device
- * @param block_size Block size
- * @param ncb Place to store number of blocks to check.
- */
-static void calc_num_check_blocks(aoff64_t nblocks, size_t block_size,
-    aoff64_t *ncb)
-{
-	aoff64_t n;
-
-	/* Check first 16 kiB / 16 blocks, whichever is more */
-	n = (min_empty_bytes + block_size - 1) / block_size;
-	if (n < min_empty_blocks)
-		n = min_empty_blocks;
-	/*
-	 * Limit to half of the device so we do not process the same blocks
-	 * twice
-	 */
-	if (n > (nblocks + 1) / 2)
-		n = (nblocks + 1) / 2;
-
-	*ncb = n;
-}
 
 int volsrv_part_is_empty(service_id_t sid, bool *rempty)
 {
 	int rc;
-	bool block_inited = false;
-	void *buf = NULL;
-	aoff64_t nblocks;
-	aoff64_t n;
-	aoff64_t i;
-	size_t block_size;
-	bool empty;
+	label_bd_t lbd;
 
 	rc = block_init(sid, 2048);
@@ -114,77 +66,13 @@
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Error opening "
 		    "block device service %zu", sid);
-		rc = EIO;
-		goto error;
+		return EIO;
 	}
 
-	block_inited = true;
+	lbd.ops = &empty_bd_ops;
+	lbd.arg = (void *)&sid;
 
-	rc = block_get_bsize(sid, &block_size);
-	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_ERROR, "Error getting "
-		    "block size.");
-		rc = EIO;
-		goto error;
-	}
+	rc = label_bd_is_empty(&lbd, rempty);
 
-	rc = block_get_nblocks(sid, &nblocks);
-	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_ERROR, "Error getting "
-		    "number of blocks.");
-		rc = EIO;
-		goto error;
-	}
-
-	calc_num_check_blocks(nblocks, block_size, &n);
-
-	buf = calloc(block_size, 1);
-	if (buf == NULL) {
-		log_msg(LOG_DEFAULT, LVL_ERROR, "Error allocating buffer.");
-		rc = ENOMEM;
-		goto error;
-	}
-
-	empty = true;
-
-	for (i = 0; i < n; i++) {
-		rc = block_read_direct(sid, i, 1, buf);
-		if (rc != EOK) {
-			log_msg(LOG_DEFAULT, LVL_ERROR, "Error "
-			    "reading blocks.");
-			rc = EIO;
-			goto error;
-		}
-
-		if (!mem_is_zero(buf, block_size)) {
-			empty = false;
-			goto done;
-		}
-	}
-
-	for (i = 0; i < n; i++) {
-		rc = block_read_direct(sid, nblocks - n + i, 1, buf);
-		if (rc != EOK) {
-			log_msg(LOG_DEFAULT, LVL_ERROR, "Error "
-			    "reading blocks.");
-			rc = EIO;
-			goto error;
-		}
-
-		if (!mem_is_zero(buf, block_size)) {
-			empty = false;
-			goto done;
-		}
-	}
-
-done:
 	block_fini(sid);
-	free(buf);
-	*rempty = empty;
-	return EOK;
-error:
-	if (block_inited)
-		block_fini(sid);
-	if (buf != NULL)
-		free(buf);
 	return rc;
 }
@@ -193,10 +81,5 @@
 {
 	int rc;
-	bool block_inited = false;
-	void *buf = NULL;
-	aoff64_t nblocks;
-	aoff64_t n;
-	aoff64_t i;
-	size_t block_size;
+	label_bd_t lbd;
 
 	rc = block_init(sid, 2048);
@@ -204,64 +87,42 @@
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Error opening "
 		    "block device service %zu", sid);
-		rc = EIO;
-		goto error;
+		return EIO;
 	}
 
-	block_inited = true;
+	lbd.ops = &empty_bd_ops;
+	lbd.arg = (void *)&sid;
 
-	rc = block_get_bsize(sid, &block_size);
-	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_ERROR, "Error getting "
-		    "block size.");
-		rc = EIO;
-		goto error;
-	}
-
-	rc = block_get_nblocks(sid, &nblocks);
-	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_ERROR, "Error getting "
-		    "number of blocks.");
-		rc = EIO;
-		goto error;
-	}
-
-	calc_num_check_blocks(nblocks, block_size, &n);
-
-	buf = calloc(block_size, 1);
-	if (buf == NULL) {
-		log_msg(LOG_DEFAULT, LVL_ERROR, "Error allocating buffer.");
-		rc = ENOMEM;
-		goto error;
-	}
-
-	for (i = 0; i < n; i++) {
-		rc = block_write_direct(sid, i, 1, buf);
-		if (rc != EOK) {
-			log_msg(LOG_DEFAULT, LVL_ERROR, "Error "
-			    "reading blocks.");
-			rc = EIO;
-			goto error;
-		}
-	}
-
-	for (i = 0; i < n; i++) {
-		rc = block_write_direct(sid, nblocks - n + i, 1, buf);
-		if (rc != EOK) {
-			log_msg(LOG_DEFAULT, LVL_ERROR, "Error "
-			    "reading blocks.");
-			rc = EIO;
-			goto error;
-		}
-	}
+	rc = label_bd_empty(&lbd);
 
 	block_fini(sid);
-	free(buf);
-	return EOK;
-error:
-	if (block_inited)
-		block_fini(sid);
-	if (buf != NULL)
-		free(buf);
 	return rc;
+}
+
+/** Get block size wrapper for liblabel */
+static int empty_get_bsize(void *arg, size_t *bsize)
+{
+	service_id_t svc_id = *(service_id_t *)arg;
+	return block_get_bsize(svc_id, bsize);
+}
+
+/** Get number of blocks wrapper for liblabel */
+static int empty_get_nblocks(void *arg, aoff64_t *nblocks)
+{
+	service_id_t svc_id = *(service_id_t *)arg;
+	return block_get_nblocks(svc_id, nblocks);
+}
+
+/** Read blocks wrapper for liblabel */
+static int empty_read(void *arg, aoff64_t ba, size_t cnt, void *buf)
+{
+	service_id_t svc_id = *(service_id_t *)arg;
+	return block_read_direct(svc_id, ba, cnt, buf);
+}
+
+/** Write blocks wrapper for liblabel */
+static int empty_write(void *arg, aoff64_t ba, size_t cnt, const void *data)
+{
+	service_id_t svc_id = *(service_id_t *)arg;
+	return block_write_direct(svc_id, ba, cnt, data);
 }
 
Index: uspace/srv/volsrv/mkfs.c
===================================================================
--- uspace/srv/volsrv/mkfs.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/volsrv/mkfs.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -40,4 +40,5 @@
 #include <stdarg.h>
 #include <stdlib.h>
+#include <str.h>
 #include <str_error.h>
 #include <task.h>
@@ -101,5 +102,5 @@
 
 
-int volsrv_part_mkfs(service_id_t sid, vol_fstype_t fstype)
+int volsrv_part_mkfs(service_id_t sid, vol_fstype_t fstype, const char *label)
 {
 	const char *cmd;
@@ -131,9 +132,29 @@
 		return rc;
 
-	rc = cmd_runl(cmd, cmd, svc_name, NULL);
+	if (str_size(label) > 0)
+		rc = cmd_runl(cmd, cmd, "--label", label, svc_name, NULL);
+	else
+		rc = cmd_runl(cmd, cmd, svc_name, NULL);
+
 	free(svc_name);
 	return rc;
 }
 
+void volsrv_part_get_lsupp(vol_fstype_t fstype, vol_label_supp_t *vlsupp)
+{
+	vlsupp->supported = false;
+
+	switch (fstype) {
+	case fs_exfat:
+	case fs_fat:
+		vlsupp->supported = true;
+		break;
+	case fs_minix:
+	case fs_ext4:
+	case fs_cdfs:
+		break;
+	}
+}
+
 /** @}
  */
Index: uspace/srv/volsrv/mkfs.h
===================================================================
--- uspace/srv/volsrv/mkfs.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/volsrv/mkfs.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -41,5 +41,6 @@
 #include <types/vol.h>
 
-extern int volsrv_part_mkfs(service_id_t, vol_fstype_t);
+extern int volsrv_part_mkfs(service_id_t, vol_fstype_t, const char *);
+extern void volsrv_part_get_lsupp(vol_fstype_t, vol_label_supp_t *);
 
 #endif
Index: uspace/srv/volsrv/part.c
===================================================================
--- uspace/srv/volsrv/part.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/volsrv/part.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -143,10 +143,67 @@
 }
 
-static int vol_part_add_locked(service_id_t sid)
-{
-	vol_part_t *part;
+static int vol_part_probe(vol_part_t *part)
+{
 	bool empty;
 	vfs_fs_probe_info_t info;
 	struct fsname_type *fst;
+	char *label;
+	int rc;
+
+	log_msg(LOG_DEFAULT, LVL_NOTE, "Probe partition %s", part->svc_name);
+
+	assert(fibril_mutex_is_locked(&vol_parts_lock));
+
+	fst = &fstab[0];
+	while (fst->name != NULL) {
+		rc = vfs_fsprobe(fst->name, part->svc_id, &info);
+		if (rc == EOK)
+			break;
+		++fst;
+	}
+
+	if (fst->name != NULL) {
+		log_msg(LOG_DEFAULT, LVL_NOTE, "Found %s, label '%s'",
+		    fst->name, info.label);
+		label = str_dup(info.label);
+		if (label == NULL) {
+			rc = ENOMEM;
+			goto error;
+		}
+
+		part->pcnt = vpc_fs;
+		part->fstype = fst->fstype;
+		part->label = label;
+	} else {
+		log_msg(LOG_DEFAULT, LVL_NOTE, "Partition does not contain "
+		    "a recognized file system.");
+
+		rc = volsrv_part_is_empty(part->svc_id, &empty);
+		if (rc != EOK) {
+			log_msg(LOG_DEFAULT, LVL_ERROR, "Failed determining if "
+			    "partition is empty.");
+			rc = EIO;
+			goto error;
+		}
+
+		label = str_dup("");
+		if (label == NULL) {
+			rc = ENOMEM;
+			goto error;
+		}
+
+		part->pcnt = empty ? vpc_empty : vpc_unknown;
+		part->label = label;
+	}
+
+	return EOK;
+
+error:
+	return rc;
+}
+
+static int vol_part_add_locked(service_id_t sid)
+{
+	vol_part_t *part;
 	int rc;
 
@@ -171,32 +228,7 @@
 	}
 
-	log_msg(LOG_DEFAULT, LVL_NOTE, "Probe partition %s", part->svc_name);
-
-	fst = &fstab[0];
-	while (fst->name != NULL) {
-		rc = vfs_fsprobe(fst->name, sid, &info);
-		if (rc == EOK)
-			break;
-		++fst;
-	}
-
-	if (fst->name != NULL) {
-		log_msg(LOG_DEFAULT, LVL_NOTE, "Found %s, label '%s'",
-		    fst->name, info.label);
-		part->pcnt = vpc_fs;
-		part->fstype = fst->fstype;
-	} else {
-		log_msg(LOG_DEFAULT, LVL_NOTE, "Partition does not contain "
-		    "a recognized file system.");
-
-		rc = volsrv_part_is_empty(sid, &empty);
-		if (rc != EOK) {
-			log_msg(LOG_DEFAULT, LVL_ERROR, "Failed determining if "
-			    "partition is empty.");
-			goto error;
-		}
-
-		part->pcnt = empty ? vpc_empty : vpc_unknown;
-	}
+	rc = vol_part_probe(part);
+	if (rc != EOK)
+		goto error;
 
 	list_append(&part->lparts, &vol_parts);
@@ -305,5 +337,6 @@
 }
 
-int vol_part_mkfs_part(vol_part_t *part, vol_fstype_t fstype)
+int vol_part_mkfs_part(vol_part_t *part, vol_fstype_t fstype,
+    const char *label)
 {
 	int rc;
@@ -311,13 +344,26 @@
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "vol_part_mkfs_part()");
 
-	rc = volsrv_part_mkfs(part->svc_id, fstype);
+	fibril_mutex_lock(&vol_parts_lock);
+
+	rc = volsrv_part_mkfs(part->svc_id, fstype, label);
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_DEBUG, "vol_part_mkfs_part() - failed %d",
 		    rc);
+		fibril_mutex_unlock(&vol_parts_lock);
 		return rc;
 	}
 
-	part->pcnt = vpc_fs;
-	part->fstype = fstype;
+	/*
+	 * Re-probe the partition to update information. This is needed since
+	 * the FS can make conversions of the volume label (e.g. make it
+	 * uppercase).
+	 */
+	rc = vol_part_probe(part);
+	if (rc != EOK) {
+		fibril_mutex_unlock(&vol_parts_lock);
+		return rc;
+	}
+
+	fibril_mutex_unlock(&vol_parts_lock);
 	return EOK;
 }
@@ -327,4 +373,5 @@
 	pinfo->pcnt = part->pcnt;
 	pinfo->fstype = part->fstype;
+	str_cpy(pinfo->label, sizeof(pinfo->label), part->label);
 	return EOK;
 }
Index: uspace/srv/volsrv/part.h
===================================================================
--- uspace/srv/volsrv/part.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/volsrv/part.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -49,5 +49,5 @@
 extern int vol_part_find_by_id(service_id_t, vol_part_t **);
 extern int vol_part_empty_part(vol_part_t *);
-extern int vol_part_mkfs_part(vol_part_t *, vol_fstype_t);
+extern int vol_part_mkfs_part(vol_part_t *, vol_fstype_t, const char *);
 extern int vol_part_get_info(vol_part_t *, vol_part_info_t *);
 
Index: uspace/srv/volsrv/types/part.h
===================================================================
--- uspace/srv/volsrv/types/part.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/volsrv/types/part.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -52,4 +52,6 @@
 	/** Filesystem type */
 	vol_fstype_t fstype;
+	/** Volume label */
+	char *label;
 } vol_part_t;
 
Index: uspace/srv/volsrv/volsrv.c
===================================================================
--- uspace/srv/volsrv/volsrv.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/volsrv/volsrv.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -46,4 +46,5 @@
 #include <types/vol.h>
 
+#include "mkfs.h"
 #include "part.h"
 
@@ -131,5 +132,4 @@
 	async_answer_0(iid, EOK);
 }
-
 
 static void vol_part_info_srv(ipc_callid_t iid, ipc_call_t *icall)
@@ -204,4 +204,42 @@
 }
 
+static void vol_part_get_lsupp_srv(ipc_callid_t iid, ipc_call_t *icall)
+{
+	vol_fstype_t fstype;
+	vol_label_supp_t vlsupp;
+	int rc;
+
+	fstype = IPC_GET_ARG1(*icall);
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "vol_part_get_lsupp_srv(%u)",
+	    fstype);
+
+	volsrv_part_get_lsupp(fstype, &vlsupp);
+
+	ipc_callid_t callid;
+	size_t size;
+	if (!async_data_read_receive(&callid, &size)) {
+		async_answer_0(callid, EREFUSED);
+		async_answer_0(iid, EREFUSED);
+		return;
+	}
+
+	if (size != sizeof(vol_label_supp_t)) {
+		async_answer_0(callid, EINVAL);
+		async_answer_0(iid, EINVAL);
+		return;
+	}
+
+	rc = async_data_read_finalize(callid, &vlsupp,
+	    min(size, sizeof(vlsupp)));
+	if (rc != EOK) {
+		async_answer_0(callid, rc);
+		async_answer_0(iid, rc);
+		return;
+	}
+
+	async_answer_0(iid, EOK);
+}
+
+
 static void vol_part_mkfs_srv(ipc_callid_t iid, ipc_call_t *icall)
 {
@@ -209,4 +247,5 @@
 	vol_part_t *part;
 	vol_fstype_t fstype;
+	char *label;
 	int rc;
 
@@ -214,19 +253,29 @@
 	fstype = IPC_GET_ARG2(*icall);
 
+	rc = async_data_write_accept((void **)&label, true, 0, VOL_LABEL_MAXLEN,
+	    0, NULL);
+	if (rc != EOK) {
+		async_answer_0(iid, rc);
+		return;
+	}
+
+	printf("vol_part_mkfs_srv: label=%p\n", label);
+	if (label!=NULL) printf("vol_part_mkfs_srv: label='%s'\n", label);
+
 	rc = vol_part_find_by_id(sid, &part);
 	if (rc != EOK) {
+		free(label);
 		async_answer_0(iid, ENOENT);
 		return;
 	}
 
-	rc = vol_part_mkfs_part(part, fstype);
-	if (rc != EOK) {
-		async_answer_0(iid, rc);
-		return;
-	}
-
-	part->pcnt = vpc_fs;
-	part->fstype = fstype;
-
+	rc = vol_part_mkfs_part(part, fstype, label);
+	if (rc != EOK) {
+		free(label);
+		async_answer_0(iid, rc);
+		return;
+	}
+
+	free(label);
 	async_answer_0(iid, EOK);
 }
@@ -263,4 +312,7 @@
 			vol_part_empty_srv(callid, &call);
 			break;
+		case VOL_PART_LSUPP:
+			vol_part_get_lsupp_srv(callid, &call);
+			break;
 		case VOL_PART_MKFS:
 			vol_part_mkfs_srv(callid, &call);
